/********************************************************************************
Tampa IASA (Tampa, FL. 2011-02-24)

Dmitri V. Korotkevitch "Database Design for non-database architects"

( dmitri@aboutsqlserver.com )

How Row size affects performance
********************************************************************************/
use IASA
go

select top 10 * from dbo.SmallRow
go

-- checking # of the pages in the both tables
select page_count, * from sys.dm_db_index_physical_stats(DB_ID(),OBJECT_ID(N'LargeRow'),null, null, null)
select page_count, * from sys.dm_db_index_physical_stats(DB_ID(),OBJECT_ID(N'SmallRow'),null, null, null)
go

/* performance */
dbcc dropcleanbuffers
dbcc freeproccache
go

set statistics io on
go


declare 
	@StartTime datetime = getDate()

select COUNT(*) from dbo.LargeRow where IntField % 2 = 0
select datediff(millisecond,@StartTime,getDate()) as [Exec Time]
go



dbcc dropcleanbuffers
dbcc freeproccache
go

set statistics io on
go

declare 
	@StartTime datetime = getDate()

select 	COUNT(*) from dbo.SmallRow where IntField % 2 = 0
select datediff(millisecond,@StartTime,getDate()) as [Exec Time]
go
